@echo off
    setlocal enableextensions disabledelayedexpansion

    rem Where to find java information in registry
    set "javaKey=HKLM\SOFTWARE\JavaSoft\Java Runtime Environment"

    rem Get current java version
    set "javaVersion="
    for /f "tokens=3" %%v in ('reg query "%javaKey%" /v "CurrentVersion" 2^>nul') do set "javaVersion=%%v"

    rem Test if a java version has been found
    if not defined javaVersion (
        echo Java version not found,please install Java Runtime Environment!!
        goto endProcess
    )

    rem Get java home for current java version
    set "javaDir="
    for /f "tokens=2,*" %%d in ('reg query "%javaKey%\%javaVersion%" /v "JavaHome" 2^>nul') do set "javaDir=%%e"

    if not defined javaDir (
        echo Java directory not found,please install Java Runtime Environment!!
    ) else (
        echo Java path: %javaDir%
    )

:endProcess 
    endlocal
:menu
echo ************ Menu ************************
echo [1] : Create working directory
echo [2] : Pull files from your device
echo [3] : Deodex files
echo [4] : Add deodexed files to zip
echo [5] : Zipalign apk
echo [6] : Exit
echo ******************************************
set /p NUM="Select >"
if "%NUM%"=="1" goto wodir
if "%NUM%"=="2" goto pfile
if "%NUM%"=="3" goto dex
if "%NUM%"=="4" goto azip
if "%NUM%"=="5" goto zipal
if "%NUM%"=="6" goto exit

:wodir
cls
@echo Creating working directory and output folders...
@echo app
mkdir system
mkdir system\app
mkdir system\priv-app
mkdir system\framework
@echo Please dismiss error if you already have output folders.
pause
cls
goto menu


:pfile
cls
@echo Connect your device to PC...
pause
cmd\adb kill-server
cmd\adb start-server
@echo Pulling files from your device...
cmd\adb pull /system/app system\app
cmd\adb pull /system/priv-app system\priv-app
cmd\adb pull /system/framework system\framework
pause
cls
goto menu

:dex
cls
@echo;
@echo Starting deodex...
mkdir work
@echo Starting deodex >log.txt 2>&1
@echo; >>log.txt 2>&1

if exist system\framework\playstationcertified.odex (
ren system\framework\playstationcertified.odex com.playstation.playstationcertified.odex
)
if exist system\framework\cneapiclient_release.odex (
ren system\framework\cneapiclient_release.odex cneapiclient.odex
)
if exist system\framework\com.quicinc.cne_release.odex (
ren system\framework\com.quicinc.cne_release.odex com.quicinc.cne.odex
)

for %%i in (system\app\*.apk) do (
@echo; >>log.txt 2>&1
echo TargetF%%i >>log.txt 2>&1
echo Deodexing %%i
if exist system\app\%%~ni.odex (
@echo Decompiling %%~ni.odex >>log.txt 2>&1
java -jar cmd\baksmali.jar -d system\framework -x system\app\%%~ni.odex -o work\%%~ni >>log.txt 2>&1
@echo Compiling %%~ni >>log.txt 2>&1
java -jar cmd\smali.jar work\%%~ni -o classes.dex >>log.txt 2>&1
@echo Zipping to %%~ni.apk >>log.txt 2>&1
cmd\7za a -tzip %%i classes.dex >>log.txt 2>&1
del classes.dex >>log.txt 2>&1
del system\app\%%~ni.odex >>log.txt 2>&1
)
)

for %%i in (system\priv-app\*.apk) do (
@echo; >>log.txt 2>&1
echo TargetF%%i >>log.txt 2>&1
echo Deodexing %%i
if exist system\priv-app\%%~ni.odex (
@echo Decompiling %%~ni.odex >>log.txt 2>&1
java -jar cmd\baksmali.jar -d system\framework -x system\priv-app\%%~ni.odex -o work\%%~ni >>log.txt 2>&1
@echo Compiling %%~ni >>log.txt 2>&1
java -jar cmd\smali.jar work\%%~ni -o classes.dex >>log.txt 2>&1
@echo Zipping to %%~ni.apk >>log.txt 2>&1
cmd\7za a -tzip %%i classes.dex >>log.txt 2>&1
del classes.dex >>log.txt 2>&1
del system\priv-app\%%~ni.odex >>log.txt 2>&1
)
)

for %%i in (system\framework\*.apk) do (
@echo; >>log.txt 2>&1
echo TargetF%%i >>log.txt 2>&1
echo Deodexing %%i
if exist system\framework\%%~ni.odex (
@echo Decompiling %%~ni.odex >>log.txt 2>&1
java -jar cmd\baksmali.jar -d system\framework -x system\framework\%%~ni.odex -o work\%%~ni >>log.txt 2>&1
@echo Compiling %%~ni >>log.txt 2>&1
java -jar cmd\smali.jar work\%%~ni -o classes.dex >>log.txt 2>&1
@echo Zipping to %%~ni.apk >>log.txt 2>&1
cmd\7za a -tzip %%i classes.dex >>log.txt 2>&1
del classes.dex >>log.txt 2>&1
del system\framework\%%~ni.odex >>log.txt 2>&1
)
)

for %%i in (system\framework\*.jar) do (
@echo; >>log.txt 2>&1
echo TargetF%%i >>log.txt 2>&1
echo Deodexing %%i
if exist system\framework\%%~ni.odex (
@echo Decompiling %%~ni.odex >>log.txt 2>&1
java -jar cmd\baksmali.jar -d system\framework -x system\framework\%%~ni.odex -o work\%%~ni >>log.txt 2>&1
@echo Compiling %%~ni >>log.txt 2>&1
java -jar cmd\smali.jar work\%%~ni -o classes.dex >>log.txt 2>&1
@echo Zipping to %%~ni.jar >>log.txt 2>&1
cmd\7za a -tzip %%i classes.dex >>log.txt 2>&1
del classes.dex >>log.txt 2>&1
del system\framework\%%~ni.odex >>log.txt 2>&1
)
)

for %%i in (system\app\*.odex) do (
@echo %%i was not deodexed.
@echo Not deodexedF%%i >>log.txt 2>&1
)
for %%i in (system\priv-app\*.odex) do (
@echo %%i was not deodexed.
@echo Not deodexedF%%i >>log.txt 2>&1
)
for %%i in (system\framework\*.odex) do (
@echo %%i was not deodexed.
@echo Not deodexedF%%i >>log.txt 2>&1
)

@echo;
@echo Deodexed files are stored in system\app, system\priv-app, system\framework folder.
@echo Log is saved in log.txt.
pause
cls
goto menu

:azip
cls
@echo;
@echo Adding deodexed files to deodex_install.zip
set TEMPDATE=%date:~-10,4%%date:~-5,2%%date:~-2,2%
set TEMPTIME2=%time: =0%
set TEMPTIME=%TEMPTIME2:~0,2%%time:~3,2%
copy cmd\deodex_install.zip deodex_install_%TEMPDATE%-%TEMPTIME%.zip
cmd\7za a -tzip deodex_install_%TEMPDATE%-%TEMPTIME%.zip system
@echo Deleting work folder...
rmdir /Q /S work >>log.txt 2>&1
@echo Completed.
@echo Log is saved in log.txt.
pause
cls
goto menu

:zipal
cls
for %%i in (system\app\*.apk) do (
if exist system\app\%%~ni.apk (
cmd\zipalign -f 4 system\app\%%~ni.apk system\app\zipal_%%~ni.apk
del /Q system\app\%%~ni.apk
ren system\app\zipal_%%~ni.apk %%~ni.apk
)
)

for %%i in (system\priv-app\*.apk) do (
if exist system\priv-app\%%~ni.apk (
cmd\zipalign -f 4 system\priv-app\%%~ni.apk system\priv-app\zipal_%%~ni.apk
del /Q system\priv-app\%%~ni.apk
ren system\priv-app\zipal_%%~ni.apk %%~ni.apk
)
)

for %%i in (system\framework\*.apk) do (
if exist system\framework\%%~ni.apk (
cmd\zipalign -f 4 system\framework\%%~ni.apk system\framework\zipal_%%~ni.apk
del /Q system\framework\%%~ni.apk
ren system\framework\zipal_%%~ni.apk %%~ni.apk
)
)
@echo;
@echo Zipalign completed.
pause
cls
goto menu
:exit
cls